#!/usr/bin/env bash
PID=$$
FIFO=/tmp/FIFO${PID}
mkfifo ${FIFO}
######################################################################################################

#####################
##### FONCTIONS #####
#####################
# Calcul le temps écoulé entre 2 lancements
function calcul_temps { t=$(($2-$1)) temps=$(printf "%02dh%02dm%02ds\n" $(($t/3600)) $((($t%3600)/60)) $(($t%60))); }

# Vérfie que le disque contient assez de place pour travailler
function verif_place
{
[[ ! -e "${G2S_dossier_save:-${PWD}}" || ! -e "${G2S_fichier_mkv}" ]] && return

# Vérification de la taille dispo
place=$(df -P "${G2S_dossier_save:-${PWD}}" | awk 'NR==2{print $4}')

# Vérification de la taille du fichier
taille_fichier=$(du "${G2S_fichier_mkv}") taille_fichier=${taille_fichier%%$'\t'*}

# Envoie des informations
echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>------</red>$(eval_gettext $'Size information')<red>------</red>\\n$(eval_gettext $'Available space on the hard disk drive:') <blue>${place}</blue> ko\\n$(eval_gettext $'MKV Filesize:') <blue>${taille_fichier}</blue> ko\\n<red>------</red>$(eval_gettext $'Size information')<red>------</red>\\n"

# Comparaison entre les 2 tailles, necessite environ 2 fois la taille du mkv d'origine
taille_fichier=$((${taille_fichier}*2))
if (( ${place} < ${taille_fichier} ))
then
	# Envoie des informations
	echo "SET@_progressbar1.set_text(' $(eval_gettext $'Caution: Low disk space.') ')"
	echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'The available space on the disk is low, it is recommanded to have the double of mkv file size avaiable.')\\n"
fi
}

function _dts_ac3 { dts_ac3=${1}; echo "TREE@@HIZO@@treeview1"; }

function _encapsulage { encapsulage=${1}; }

##################################################
##### ETAPE 1 : SELECTION DU FICHIER/DOSSIER #####
##################################################
function _fichier_mkv
{
if [[ ${@} =~ ^drop ]]
then
	# En cas de drop, gnome fait des truc zarb avec les espaces en autre
	fichier=$(echo -e "${@//\%/\\x}") fichier="${fichier#*file:??}"

	# Si fichier identique, on quitte
	[[ "${fichier}" ==  "${G2S_fichier_mkv}" ]] && return || echo "SET@_fichier_mkv.set_filename('${fichier}')"

elif [[ ! -f "${@}" ]]
then
	# Si fichier identique ou fichier inexistant, on quitte
	return
fi

# Aller retour de la barre pendant le chargement des infos
while true; do echo 'SET@_progressbar1.pulse()'; sleep 0.1; done &
pid_pulse=${!}

# Récupération du nom du fichier mkv et de son adresse
G2S_fichier_mkv="${@}" nom_fichier=${G2S_fichier_mkv##*/}

# Arrete la lecture si besoin
action_video stop

# Modifications graphiques
[[ ${G2S_auto_save} == True ]] && echo "SET@_dossier_save.set_current_folder('${G2S_fichier_mkv%/*}')"
echo 'MULTI@@SET@@clear()@@store_treeview1,store_tree_pistes'
echo 'MULTI@@SET@@columns_autosize()@@treeview1,tree_pistes'
echo 'TEXT@@CLEAR@@_textedebug'
echo 'MULTI@@SET@@hide()@@_scrolle_txt,_video_box,_mediaview,_webbox'
echo 'SET@_hbox_img.show()'
echo "IMG@@_visualisation_img@@/usr/share/icons/hicolor/256x256/apps/mkv-extractor-gui.png@@${_visualisation_img_scale% *}@@${_visualisation_img_scale#* }"
echo 'MULTI@@SET@@set_sensitive(False)@@_table1,_open_media,_info_media'
dts_ac3=False encapsulage= False

# Suppression du contenu du dossier temporaire s'il existe
[[ ! -d "${tmp}" ]] && mkdir -p "${tmp}" || rm "${tmp}"/* &

# Info pour le debug
echo "TEXT@@ENDTAG@@_textedebug@@$(eval_gettext $'Opening the mkv file:') <blue>${G2S_fichier_mkv}</blue>\\n"

# Récupération des infos du fichier
mkv_mkvmerge=$(export LANGUAGE=en; mkvmerge -I "${G2S_fichier_mkv}" | sed "s/codec_private_data:[0-9a-zA-Z]* //")
mkv_mkvmerge=${mkv_mkvmerge//\\c/:}

# Info pour le debug profond
if [[ ${G2S_debug} == True ]]
then
	mkvmerge_v=$(mkvmerge -V | sed 's/.*v// ; s/ .*//')
	[[ -e /etc/lsb-release ]] && source /etc/lsb-release

	[[ ${DISTRIB_DESCRIPTION} ]] && echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>------</red>$(eval_gettext $'Global information')<red>------</red>\\n$(eval_gettext $'Ubuntu version:') <blue>${DISTRIB_DESCRIPTION} - ${DISTRIB_CODENAME} - $(uname -m)</blue>\\n"
	echo "TEXT@@ENDTAG@@_textedebug@@$(eval_gettext $'Mkvmerge version:') <blue>${mkvmerge_v}</blue>\\n$(eval_gettext $'MKV Extractor Gui version:') <blue>${version}</blue>\\n<red>------</red>$(eval_gettext $'Global information')<red>------</red>\\n"

	retour_mkvmerge=${mkv_mkvmerge//$'\n'/\\n\\n} retour_mkvmerge=${retour_mkvmerge//\\s/ }

	echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>------</red>$(eval_gettext $'Post information mkvmerge')<red>------</red>\\nfichier_mkv : <blue>${G2S_fichier_mkv}</blue>\\nnom_fichier : <blue>${nom_fichier}</blue>\\nmkv_mkvmerge : <blue>${retour_mkvmerge}</blue>\\n<red>------</red>$(eval_gettext $'Post information mkvmerge')<red>------</red>\\n"
fi

if [[ ${mkv_mkvmerge} =~ "container: Matroska" ]]
then
	# Lance la vérification de place
	verif_place &

	# Récupération du titre du fichier si précisé sinon utilise le nom du fichier
	[[ ${mkv_mkvmerge} =~ "[title:" ]] && titre=$(sed -n '1s/.*\[title:\(.*\) duration.*/\1/p' <<< "${mkv_mkvmerge//\\s/ }") || titre="${nom_fichier}"

	# Si le titre existe, on l'utilise, sinon c'est le nom du fichier
	echo "SET@_progressbar1.set_text(' $(eval_gettext $'Opening:') ${titre} ')"

	# Suppression de la 1ere ligne contenant le nom du fichier et le conteneur
	mkv_mkvmerge="${mkv_mkvmerge#*$'\n'}"

	# En fonction de la version de mkvmerge, les ID debute à 0 ou 1
	[[ "${mkv_mkvmerge}" =~ ^"Track ID 0:" ]] && decalage_id=0 || decalage_id=1

	# Récupération de toutes les infos du fichier mkv via ffmpeg
	mkv_ffmpeg=$(export LANGUAGE=en; ffmpeg -i "${G2S_fichier_mkv}" 2>&1)

	# Info pour le debug profond
	if [[ ${G2S_debug} == True ]]
	then
		retour_ffmepg="Input #0${mkv_ffmpeg##*Input #0}" retour_ffmepg=${retour_ffmepg%$'\n'*} retour_ffmepg=${retour_ffmepg//$'\n'/\\n}

		echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>------</red>$(eval_gettext $'Post information ffmpeg')<red>------</red>\\ntitre : <blue>${titre}</blue>\\ndecalage_id : <blue>${decalage_id}</blue>\\nmkv_ffmpeg : \\n<blue>${retour_ffmepg}</blue>\\n<red>------</red>$(eval_gettext $'Post information ffmpeg')<red>------</red>\\n"
	fi

	# Lancement de la fonction scan => envoie vers l'etape 2
	scan

else
	echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'mkvmerge does not recognize:') <blue>${G2S_fichier_mkv}</blue>.\\n"
	echo "SET@_progressbar1.set_text(' $(eval_gettext $'Error: see the debug.') ')"
fi

# Retour à au début des treeview
echo 'MULTI@@SET@@scroll_to_cell(0)@@treeview1,tree_pistes'

# Arret de la barre et remise à 0
kill ${pid_pulse}
sleep 0.2
echo 'SET@_progressbar1.set_fraction(0)'

# Dégrisage des widgets
echo 'MULTI@@SET@@set_sensitive(True)@@_mkvinfo,_table1,_vbox5'
}


###############################################
##### ETAPE 2 : CHARGEMENT DU FICHIER MKV #####
###############################################
function scan
{
# Boucle permettant de travailler sur la liste de track
while read track
do
	# Récupération du type de track
	type=${track#*: } type_plus=${type#*/} type_plus=${type_plus%%?,*} type=${type%% *} autre_type=${track%%:*}

	if [[ ${type} == video || ${type} == audio || ${type} == subtitles || ${type} == type ]]
	then
		case ${type} in
			video)
				# Récupération des variables
				icone='video-x-generic'
				ID=${track#*ID } ID=${ID%%:*}

				codec=$(sed -n "/Stream #0.$((${ID}-${decalage_id}))/ s/.*Video: \([[:alnum:]]*\).*/\1/p" <<< "${mkv_ffmpeg}")

				# Récupération de la valeur si l'information track_name existe sinon utilisation de la resolution
				[[ "${track}" =~ "track_name:" ]] && info1=${track#*track_name:} info1=${info1%% *} info1=${info1//-_-/ } || info1=${track#*display_dimensions:} info1=${info1%% *}

				# Récupération des fps
				info2=$(sed -n "/Stream #0.$((${ID}-${decalage_id}))/ s/.*, \([0-9][0-9].*\) fps.*/\1 fps/p" <<< "${mkv_ffmpeg}")

				# Modification du nombre de fps 23.98 en 23.976
				[[ ${info2} == "23.98 fps" ]] && info2="23.976 fps"

				# Si pas de fps, on recherche avec mkvinfo
				[[ -z ${info2} ]] && info2=$(export LANGUAGE=en; mkvinfo -s "${G2S_fichier_mkv}" | head -10 | sed -n '/^Track .: video,/ s/.*[0-9]ms .\([0-9][0-9].*\) fps.*/\1 fps/p') ;;

			audio)
				# Récupération des variables
				icone='audio-x-generic'
				ID=${track#*ID } ID=${ID%%:*}

				# Récupération du codec avec ID - 1 ou 0 en fonction de la version de mkvmerge
				codec=$(sed -n "/Stream #0.$((${ID}-${decalage_id}))/ s/.*Audio: \([[:alnum:]]*\).*/\1/p" <<< "${mkv_ffmpeg}") codec=${codec/dca/dts}

				# Récupération de la valeur si l'information track_name existe
				if [[ "${track}" =~ "track_name:" ]]
				then
					info1=${track#*track_name:} info1=${info1%% *} info1=${info1//-_-/ }

				# Récupération de la valeur si l'information audio_sampling_frequency existe
				elif [[ "${track}" =~ "audio_sampling_frequency:" ]]
				then
					info1=${track#*audio_sampling_frequency:} info1=${info1%% *} info1=${info1//-_-/ } info1="${info1} Hz"
				fi

				# Récupération de la valeur si l'information language existe
				if [[ "${track}" =~ "language:" ]]
				then
					info2=${track#*language:} info2=${info2%% *}

				# Récupération de la valeur si l'information audio_channels existe
				elif [[ "${track}" =~ "audio_channels:" ]]
				then
					info2=${track#*audio_channels:} info2=${info2%% *} info1=${info1//-_-/ } info1="${info1} $(eval_gettext $'channels')"
				fi ;;

			subtitles)
				# Récupération des variables
				ID=${track#*ID } ID=${ID%%:*}
				codec=${track#*\(?_} codec=${codec%%? *} codec=${codec,,} codec=${codec%/*}
				[[ ${codec} == text ]] && codec=srt

				# Utilisation de 2 icones differentes en fonction du sous titre
				[[ ${codec} == vobsub ]] && icone='preferences-desktop-font' || icone='text-x-generic'

				# Récupération de la valeur si l'information track_name existe
				[[ "${track}" =~ "track_name:" ]] && info1=${track#*track_name:} info1=${info1%% *} info1=${info1//-_-/ }

				# Récupération de la valeur si l'information language existe
				[[ "${track}" =~ "language:" ]] && info2=${track#*language:} info2=${info2%% *} ;;

			type)
				# Récupération des variables
				ID=${track#*ID } ID=${ID%%:*}
				type=${track#* type ?} type=${type%%/*}
				codec=${track#*/} codec=${codec%%?, *}
				info2=${track##*size } info2=${info2%%,*}

				# Si une description existe, on l'utilise sinon, on recupere le nom
				[[ "${track}" =~ ", description " ]] && info1=${track##*, description ?} info1=${info1%%?, *} || info1=${track%?} info1=${info1##*file name ?}

				# Quelques exceptions
				[[ "${type_plus}" == ogg ]] && type=media
				[[ "${type_plus}" == ogm ]] && type=video
				[[ "${type_plus}" == html ]] && type=web

				# Récupération de l'icone à utiliser
				case "${type}" in
					application*) icone="system-run" ;;
					image) icone="image-x-generic" ;;
					text) icone="accessories-text-editor" ;;
					media|video|audio) icone="applications-multimedia" ;;
					web) icone="applications-internet" ;;
					*) icone="image-missing" ;;
				esac

				# Si pas d'infos, texte de base
				[[ -z ${info1} ]] && info1="$(eval_gettext $'No name')"
				[[ -z ${info2} ]] && info2="$(eval_gettext $'No information')"

				# Envoie des infos dans le tree des fichiers joints
				[[ ${type} =~ image|text|video|audio|media|web ]] && echo "TREE@@END@@tree_pistes@@${ID}|${type}|${info1}" ;;
		esac

		# Si pas d'infos, texte de base
		[[ -z ${info1} ]] && info1="$(eval_gettext $'No name')"
		[[ -z ${info2} ]] && info2="$(eval_gettext $'No information')"

		# Envoie des infos dans le tree des pistes
		echo "TREE@@END@@treeview1@@False|${icone}|${ID}|${info1}|${codec}|${info2}"

	else
		case ${autre_type} in
			Chapters)
				# Récupération des variables
				info1=${track#*: } info1=${info1% *}
				info2=${chapters}
				icone="x-office-address-book"

				# Envoie des infos dans les tree
				echo "TREE@@END@@treeview1@@False|${icone}|X|${info2}||${info1} ${info2}"
				echo "TREE@@END@@tree_pistes@@XX|chapters|${info1} ${info2}" ;;

			"Global tags")
				# Récupération des variables
				info1=${track#*: } info1=${info1% *}
				info2=${tags}
				icone="text-html"

				# Envoie des infos dans les tree
				echo "TREE@@END@@treeview1@@False|${icone}|X|${info2}||${info1} ${info2}"
				echo "TREE@@END@@tree_pistes@@XXX|tags|${info1} ${info2}" ;;
		esac
	fi

# Info pour le debug profond
[[ ${G2S_debug} == True ]] && echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>------</red>$(eval_gettext $'Loading track')<red>------</red>\\ntrack : <blue>${track}</blue>\\ntype : <blue>${type}</blue>\\ntype_plus : <blue>${type_plus}</blue>\\nautre_type : <blue>${autre_type}</blue>\\nID : <blue>${ID}</blue>\\ncodec : <blue>${codec}</blue>\\ninfo1 : <blue>${info1}</blue>\\ninfo2 : <blue>${info2}</blue>\\nicone : <blue>${icone}</blue>\\n<red>------</red>$(eval_gettext $'Loading track')<red>------</red>\\n"

# Destruction des variables
unset type type_plus autre_type icone ID codec info1 info2

done <<< "${mkv_mkvmerge//\\s/-_-}"
}


#######################################################################
##### ETAPE 3 : SELECTION DES PISTES ET LANCEMENT DE L'EXTRACTION #####
#######################################################################
function treeview1
{
if [[ ${1} =~ drop ]]
then
	# En cas de drop => envoie à l'étape 1
	# Récupération du nom du fichier, la commande obligatoire pour gnome car change les caractères spéciaux (espace => %20)
	fichier=$(echo -e "${@//\%/\\x}") fichier="${fichier#*file:??}"

	echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'Dropped file:') <blue>${fichier}</blue>.\\n"

	# Modification des boites de sélection et lancement des fonctions avec les nouvelles valeurs
	echo "SET@_fichier_mkv.set_filename('${fichier}')"
	echo "SET@_dossier_save.set_current_folder('${fichier%/*}')"

# Si l'on clique sur l'icône d'état
elif [[ ${1} =~ toggled ]]
then
	# Récupération de létat de la coche
	etat=${@} etat=${etat#*@*@} etat=${etat%%|*}

	# Relance la fonction treeview1 avec pour argument tout le contenu du tree
	echo "TREE@@HIZO@@treeview1"

# Si l'on modifie le combo
elif [[ ${1} =~ combo ]]
then
	# Vérification du nombre de fps
	verif_fps=${@} verif_fps=${verif_fps##*|} verif_fps=${verif_fps%% *} verif_fps=${verif_fps/fps}
	ligne=${@} ligne=${ligne#*@} ligne=${ligne%%,*}
	colonne=${@} colonne=${colonne#*,} colonne=${colonne%%@*}
	texte=${@} texte=${texte#*@*@} texte=${texte%%@*}

	# Si le chamgement ne concerne pas une video, on recharge les infos
	if [[ ! "${@}" =~ video-x-generic ]]
	then
		echo "TREE@@FORCE_SELECT@@treeview1"
		echo "TREE@@CELL@@treeview1@@${ligne},${colonne}@@${texte}"

		# Info pour le debug
		echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'Only video tracks can have fps → action canceled')\\n"

	# Si le formatage n'est pas bon,
	elif [[ ! ${verif_fps} =~ ^[0-9][0-9]$|^[0-9][0-9]\.[0-9][0-9][0-9]$ ]]
	then
		echo "TREE@@FORCE_SELECT@@treeview1"
		echo "TREE@@CELL@@treeview1@@${ligne},${colonne}@@${texte}"

		# Info pour le debug
		echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'Bad format for the fps, good format: XX or XX.XXX → action canceled')\\n"

	# Si le format est le bon et que cela concerne une video
	else
		# Relance la fonction treeview1 avec pour argument tout le contenu du tree
		echo "TREE@@HIZO@@treeview1"
	fi

# Si la fonction est lancée par TREE@@HIZO@@treeview1
elif [[ ${1} =~ hizo ]]
then
	# Récupération de toutes les infos disponibles dans le tree
	tree_complet=${@#hizo?} tree_total=${tree_complet//@@/$'\n'} tree_complet=$(egrep "^True" <<< "${tree_total}")
	# Si le tree retourne des pistes séléctionnée
	if [[ ${tree_complet} ]]
	then
		# Dégrise les boutons et options
		echo 'MULTI@@SET@@set_sensitive(True)@@_bouton_extract,_encapsulage'
	else
		# Grise les boutons et options
		echo 'MULTI@@SET@@set_sensitive(False)@@_bouton_extract,_encapsulage'
		echo 'MULTI@@SET@@set_active(False)@@_encapsulage,_dts_ac3'
	fi

	# En cas de piste audio DTS
	if [[ ${tree_complet} =~ audio-x-generic.*dts ]]
	then
		# Dégrise le coche de la convertion audio
		echo 'SET@_dts_ac3.set_sensitive(True)'
	else
		# Grise, desactive le coche de la convertion audio
		echo 'SET@_dts_ac3.set_sensitive(False)'
		echo 'SET@_dts_ac3.set_active(False)'
	fi
fi
}


##################################################################
##### ETAPE 4 : CREATION DES FICHIERS MKVMERGE ET MKVEXTRACT #####
##################################################################
function _bouton_extract
{
# Sauvegarde des préférences
echo 'CONFIG@@SAVE'; sleep 0.1

# Chargement des info
echo 'CONFIG@@GET'; sleep 0.1

# Lancement de la suite
echo 'ITER@@bouton_extract_suite'
}


function bouton_extract_suite
{
# Lance la vérification de place
verif_place

# Remise à 0 des variables pour ne pas interagir entre plusiers executions
unset dts_ffmpeg mkvextract_track mkvextract_joint mkvextract_chap mkvextract_tag mkvmerge mkvmerge_ac3

case ${G2S_bitrate:-0} in
	0) G2S_bitrate=128 ;;
	1) G2S_bitrate=192 ;;
	2) G2S_bitrate=224 ;;
	3) G2S_bitrate=256 ;;
	4) G2S_bitrate=320 ;;
	5) G2S_bitrate=384 ;;
	6) G2S_bitrate=448 ;;
	7) G2S_bitrate=512 ;;
	8) G2S_bitrate=576 ;;
	9) G2S_bitrate=640 ;;
esac

case ${G2S_boost:-0} in
	0) G2S_boost=0 ;;
	1) G2S_boost=2 ;;
	2) G2S_boost=3 ;;
	3) G2S_boost=4 ;;
	4) G2S_boost=5 ;;
esac

echo "True" > "${tmp}/action_en_cours"

# Récupération de l'heure en seconde pour calculer le temps écoulé.
temps_x=$(date +%s)


# Création des commandes avec le début des differentes commandes
if [[ ${encapsulage} == True ]]
then
	# Creation du code pour mkvmerge
	mkvmerge="mkvmerge -o \"${G2S_dossier_save}/MEG_${nom_fichier}\""

	# Récupération du titre du mkv pour l'encapsulage
	[[ ${titre} ]] && mkvmerge+=" --title \"${titre}\""

	# Creation et Ajout du fichier dans la liste des fichiers temps
	fichiers=("${G2S_dossier_save}/MEG_${nom_fichier}")
fi

# Creation des codes pour l'extraction
mkvextract_track="mkvextract tracks \"${G2S_fichier_mkv}\""
mkvextract_joint="mkvextract attachments \"${G2S_fichier_mkv}\""

while read track
do
	# Sauvegarde de l'ancien IFS, Modification de l'IFS, récupération des infos, remise en place de l'IFS
	old_ifs=${IFS} IFS='|' liste=(${track}) icone=${liste[1]} ID=${liste[2]} info1=${liste[3]} codec=${liste[4]} info2=${liste[5]} IFS=${old_ifs}

	# Destruction des variables inutiles
	[[ ${info1} == "$(eval_gettext $'No name')" ]] && unset info1
	[[ ${info2} == "$(eval_gettext $'No information')" ]] && unset info2

	# Séparation des type de fichiers car commandes différentes, Récupération de l'extension
	case ${icone} in
		video-x-generic)
			# Récupération de l'extension de la piste
			case "${codec,,}" in
				rv*) extension="rm" ;;
				h264) extension="mkv" ;;
				*) extension="avi" ;;
			esac

			# Ajout du fichier dans la liste des fichiers temps
			fichiers+=("${G2S_dossier_save}/${ID}_Video_${info1}.${extension}")

			# Code pour extraction de la piste
			mkvextract_track+=" ${ID}:\"${G2S_dossier_save}/${ID}_Video_${info1}.${extension}\""

			# Code d'encapsulage
			if [[ ${encapsulage} == True ]]
			then
				# Verifie que le nombre de fps est non vide sinon donne la valeur 25000fps
				if [[ -z "${info2}" ]]
				then
					info2="25.000 fps"
					echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'<blue>FPS</blue>: invalid value, use default of 25.000 fps.')\\n"
				fi

				[[ ${info1} ]] && mkvmerge+=" --track-name \"0:${info1}\""
				mkvmerge+=" --default-duration \"0:${info2// }\" --compression \"0:none\" \"${G2S_dossier_save}/${ID}_Video_${info1}.${extension}\""
			fi ;;

		audio-x-generic)
			# En cas de fichier DTS avec conversion en AC3
			if [[ ${dts_ac3} == True && ${liste[4]} == *[Dd][Tt][Ss]* ]]
			then
				# Code pour la conversion du son
				[[ -z ${dts_ffmpeg} ]] && dts_ffmpeg="ffmpeg -y -i \"${G2S_fichier_mkv}\""

				dts_ffmpeg+=" -vn -map 0:$((${ID} - ${decalage_id}))"
				[[ ${boost_num} -gt 1 ]] && dts_ffmpeg+=" -vol ${G2S_boost_num}"
				[[ ${G2S_bitrate} -gt 0 ]] && dts_ffmpeg+=" -ab ${G2S_bitrate}k"

				[[ ${G2S_canaux} == True ]] && dts_ffmpeg+=" -ac 2"

				dts_ffmpeg+=" -f ac3 \"${G2S_dossier_save}/${ID}_Audio_${codec}_${info2}.ac3\""

				# Ajout du fichier dans la liste des fichiers temps
				fichiers+=("${G2S_dossier_save}/${ID}_Audio_${codec}_${info2}.ac3")

				# Code d'encapsulage
				if [[ ${encapsulage} == True ]]
				then
					[[ ${info2} ]] && mkvmerge+=" --language \"0:${info2}\""
					mkvmerge+=" --compression \"0:none\" --track-name \"0:AC3 ${G2S_bitrate}k\" \"${G2S_dossier_save}/${ID}_Audio_${codec}_${info2}.ac3\""
				fi

			else
				codec=${codec//vorbis/ogg}

				# Ajout du fichier dans la liste des fichiers temps
				fichiers+=("${G2S_dossier_save}/${ID}_Audio_${codec}_${info2}.${codec:-inconnu}")

				# Code pour extraction de la piste
				mkvextract_track+=" ${ID}:\"${G2S_dossier_save}/${ID}_Audio_${codec}_${info2}.${codec:-inconnu}\""

				# Code d'encapsulage
				if [[ ${encapsulage} == True ]]
				then
					[[ ${info1} ]] && mkvmerge+=" --track-name \"0:${info1}\""
					[[ ${info2} ]] && mkvmerge+=" --language \"0:${info2}\""
					mkvmerge+=" --compression \"0:none\" \"${G2S_dossier_save}/${ID}_Audio_${codec}_${info2}.${codec:-inconnu}\""
				fi
			fi ;;

		preferences-desktop-font|text-x-generic)
			codec=${codec//*sub/sub}

			# Ajout du fichier dans la liste des fichiers temps
			fichiers+=("${G2S_dossier_save}/${ID}_Sous-titres_${info2}.${codec:-inconnu}")

			# Si c'est un fichier vobsub, il y a un fichier idx de créé
			[[ ${codec} == sub ]] && fichiers+=("${G2S_dossier_save}/${ID}_Sous-titres_${info2}.idx")

			# Code pour extraction de la piste
			mkvextract_track+=" ${ID}:\"${G2S_dossier_save}/${ID}_Sous-titres_${info2}.${codec:-inconnu}\""

			# Code d'encapsulage
			if [[ ${encapsulage} == True ]]
			then
				[[ ${info1} ]] && mkvmerge+=" --track-name \"0:${info1}\""
				[[ ${info2} ]] && mkvmerge+=" --language \"0:${info2}\""
				mkvmerge+=" --compression 0:none \"${G2S_dossier_save}/${ID}_Sous-titres_${info2}."
				[[ ${codec} == sub ]] && mkvmerge+="idx\""|| mkvmerge+="${codec:-inconnu}\""
			fi ;;

		x-office-address-book)
			# Ajout du fichier dans la liste des fichiers temps
			fichiers+=("${G2S_dossier_save}/${chapters}.txt")

			# Code pour extraction des chapitres
			mkvextract_chap="mkvextract chapters \"${G2S_fichier_mkv}\" -s > \"${G2S_dossier_save}/${chapters}.txt\""

			# Code d'encapsulage
			[[ ${encapsulage} == True ]] && mkvmerge+=" --chapters \"${G2S_dossier_save}/${chapters}.txt\"" ;;

		text-html)
			# Ajout du fichier dans la liste des fichiers temps
			fichiers+=("${G2S_dossier_save}/${tags}.xml")

			# Code pour extraction des tags
			mkvextract_tag="mkvextract tags \"${G2S_fichier_mkv}\" > \"${G2S_dossier_save}/${tags}.xml\""

			# Code d'encapsulage
			[[ ${encapsulage} == True ]] && mkvmerge+=" --global-tags \"${G2S_dossier_save}/${tags}.xml\"" ;;

		*)
			# Code pour extraction du fichier joint
			mkvextract_joint+=" ${ID}:\"${G2S_dossier_save}/${ID}_${info1}\""

			# Ajout du fichier dans la liste des fichiers temps
			fichiers+=("${G2S_dossier_save}/${ID}_${info1}")

			# Code d'encapsulage
			[[ ${encapsulage} == True ]] && mkvmerge+=" --attachment-name \"${info1}\" --attach-file \"${G2S_dossier_save}/${ID}_${info1}\"" ;;
	esac

	# Info pour le debug profond
	[[ ${G2S_debug} == True ]] && echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>------</red>$(eval_gettext $'Processing track')<red>------</red>\\ntrack : <blue>${track}</blue>\\nicone : <blue>${icone}</blue>\\nID : <blue>${ID}</blue>\\ninfo1 : <blue>${info1}</blue>\\ninfo2 : <blue>${info2}</blue>\\ncodec : <blue>${codec}</blue>\\nextension : <blue>${extension}</blue>\\n<red>------</red>$(eval_gettext $'Processing track')<red>------</red>\\n"

done <<< "${tree_complet}"

# Si les variables mkvextract sont comme au debut de la fonction, on les reiniatilises
[[ ${mkvextract_track} == "mkvextract tracks \"${G2S_fichier_mkv}\"" ]] && unset mkvextract_track
[[ ${mkvextract_joint} == "mkvextract attachments \"${G2S_fichier_mkv}\"" ]] && unset mkvextract_joint

# Info pour le debug profond
[[ ${G2S_debug} == True ]] && echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>------</red>$(eval_gettext $'Files list')<red>------</red>\\nfichiers : <blue>${fichiers[@]}</blue>\\n<red>------</red>$(eval_gettext $'Files list')<red>------</red>\\n\\n$(eval_gettext $'Output folder:') <blue>${G2S_dossier_save}</blue>.\\n"

actions &
pid_actions=${!}
}


function actions
{
# Affichage de l'onglet debug
echo 'SET@_notebook2.set_current_page(3)'

# Envoie à l'étape 5a
# Lancement de l'extraction des pistes en fonction des besoins (DTS uniquement, ou total)
[[ ${mkvextract_track} || ${mkvextract_joint} || ${mkvextract_chap} || ${mkvextract_tag} ]] && extraction_piste

# Envoie à l'étape 5b
# Lancement de la conversion dts vers ac3 en fonction des besoins
[[ ${dts_ffmpeg} ]] && dts

# Envoie à l'étape 5c
# Lancement de la commande d'encapsulage de mkvmerge en fonction des besoins
[[ ${mkvmerge} ]] && encapsulage

# Enleve le nom du mkv final de la liste des fichiers
fichiers[0]=""

# Modification de l'interface (inversion des boutons stop et extraction, degrisage des widgets)
echo 'TOGGLE@@VISIBLE@@_bouton_stop,_bouton_extract'
echo 'MULTI@@SET@@set_sensitive(True)@@_table1,_vbox4,_hbox4,_vbox5'
echo 'SET@_progressbar1.set_fraction(0)'
echo 'TREE@@HIZO@@treeview1'

# Suppression des pistes temporaires si la variable contient des noms de fichiers...
if [[ ${encapsulage} == True && ${fichiers[@]} && ${G2S_fichier_tmp} == True ]]
then
	rm "${fichiers[@]}"

	# Info pour le debug profond
	if [[ ${G2S_debug} == True ]]
	then
		echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>------</red>$(eval_gettext $'Deleting files')<red>------</red>\\nfichiers : <blue>${fichiers[@]}</blue>\\n<red>------</red>$(eval_gettext $'Deleting files')<red>------</red>\\n"
	else
		echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'<blue>Deleting</blue> temporary files.')\\n"
	fi
fi

# Récupération de l'heure en seconde pour calculer le temps écoulé.
temps_y=$(date +%s)

calcul_temps temps_x temps_y

# Pause pour laisser le temps de voir le temps de la derniere action realisée
sleep 1

echo "SET@_progressbar1.set_text(' $(eval_gettext $'Total operations time:') ${temps} ')"
echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>---------------------------------------</red>\\n$(eval_gettext $'Total operations time:') <blue>${temps}</blue>.\\n<red>---------------------------------------</red>\\n"

sleep 1

echo "False" > "${tmp}/action_en_cours"

# Affichage de l'onglet des pistes
echo 'SET@_notebook2.set_current_page(1)'
}


############################################
##### ETAPE 5a : EXTRACTION DES PISTES #####
############################################
function extraction_piste()
{
# Récupération de l'heure en seconde pour calculer le temps écoulé.
temps_a=$(date +%s)

echo "SET@_progressbar1.set_text(' $(eval_gettext $'Tracks extraction in progress...') ')"

# Code pour avancer la barre pendant le travail de mkvmextract
if [[ ${mkvextract_track} ]]
then
	# Debug
	echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'mkvextract command for extracting tracks:')\\n<blue>${mkvextract_track}</blue>\\n"

	while read -d $'\r' pourcentage
	do
		# Traitement d'affichage....
		pourcentage=${pourcentage##* } pourcentage=${pourcentage%?}

		# Agrandit la barre jusqu'au pourcentage calculé
		[[ ${pourcentage} =~ ^[0-9]*$ && ${pourcentage} != ${old_pourcentage} ]] && echo "SET@_progressbar1.set_fraction($(echo "scale=2;${pourcentage:-100} / 100" | bc))"

		old_pourcentage=${pourcentage}

		# Mini sleep
		sleep 0.1
	done < <(eval ${mkvextract_track} 2>&1)
fi

# Code pour pulser la barre pendant le travail de mkvmextract
if [[ ${mkvextract_joint} ]]
then
	# Debug
	echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'mkvextract command for extracting attached files:')\\n<blue>${mkvextract_joint}</blue>\\n"

	while read -d $'\r' pourcentage
	do
		# Deplace la barre d'un bloc
		echo 'SET@_progressbar1.pulse()'

		# Mini sleep
		sleep 0.2
	done < <(eval ${mkvextract_joint} 2>&1)
fi

# Code de l'extraction des chapitres
if [[ ${mkvextract_chap} ]]
then
	# Debug
	echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'mkvextract command for extracting chapters:')\\n<blue>${mkvextract_chap//>/→}</blue>\\n"

	eval ${mkvextract_chap}
fi

# Code de l'extraction des tags
if [[ ${mkvextract_tag} ]]
then
	# Debug
	echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'mkvextract command for extracting tags:')\\n<blue>${mkvextract_tag//>/→}</blue>\\n"

	eval ${mkvextract_tag}
fi

# Récupération de l'heure en seconde pour calculer le temps écoulé.
temps_b=$(date +%s)

calcul_temps temps_a temps_b

# Debug et info
echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>---------------------------------------</red>\\n$(eval_gettext $'Track extraction completed in:') <blue>${temps}</blue>.\\n"
echo "SET@_progressbar1.set_text(' $(eval_gettext $'Track extraction completed in:') ${temps} ')"
echo 'SET@_progressbar1.set_fraction(1)'

# Pause pour voir le texte ci-dessus
sleep 0.7
}


################################
##### ETAPE 5b : DTS > AC3 #####
################################
function dts()
{
# Récupération de l'heure en seconde pour calculer le temps écoulé.
temps_a=$(date +%s)

# Récupération de la durée du film
time_film=$(date +%s -d "1970-01-01 $(sed -n '/Duration/ s/.*Duration: \([0-9][0-9]:[0-9][0-9]:[0-9][0-9]\).*/\1/p' <<< "${mkv_ffmpeg}") seconds UTC")

# Debug et info
echo "SET@_progressbar1.set_text(' $(eval_gettext $'DTS conversion in progress...') ')"
echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'ffmpeg command for the DTS => AC3 conversion:')\\n<blue>${dts_ffmpeg}</blue>\\n"

# Code pour récupérer le retour de ffmpeg
while read -d $'\r' ligne
do
	if [[ "$ligne" == *time=* ]]
	then
		# Recuperation du temps deja converti
		time=${ligne##*time=} time=${time%%.*}

		# Conversion de cet horaire en seconde
		time=$(date +%s -d "1970-01-01 ${time} seconds UTC")

		# Agrandit la barre jusqu'au pourcentage calculé
		[[ ${pourcentage} != ${old_pourcentage} ]] && echo "SET@_progressbar1.set_fraction($(echo "scale=2;${time} / ${time_film}" | bc))"

		old_pourcentage=${pourcentage}

		# Mini sleep
		sleep 0.1
	fi
done < <(eval ${dts_ffmpeg} 2>&1)

# Récupération de l'heure en seconde pour calculer le temps écoulé.
temps_b=$(date +%s)

calcul_temps temps_a temps_b

# Debug et info
echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>---------------------------------------</red>\\n$(eval_gettext $'DTS conversion completed in:') <blue>${temps}</blue>.\\n"
echo "SET@_progressbar1.set_text(' $(eval_gettext $'DTS conversion completed in:') ${temps} ')"
echo 'SET@_progressbar1.set_fraction(1)'

# mini attente
sleep 0.7
}


#############################################
##### ETAPE 5c : ENCAPSULAGE DES PISTES #####
#############################################
function encapsulage()
{
# Récupération de l'heure en seconde pour calculer le temps écoulé.
temps_a=$(date +%s)

# Debug et info
echo "SET@_progressbar1.set_text(' $(eval_gettext $'Tracks encapsulation in progress...') ')"
echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'mkvmerge command for encapsulation of tracks:')\\n<blue>${mkvmerge}</blue>\\n"

# Code pour récupérer le retour de mkvmerge
while read -d $'\r' ligne
do
	pourcentage=${ligne##* } pourcentage=${pourcentage%?}

	if [[ ${pourcentage} =~ ^[0-9]*$ ]]
	then
		# Agrandit la barre jusqu'au pourcentage calculé
		[[ ${pourcentage} != ${old_pourcentage} ]] && echo "SET@_progressbar1.set_fraction($(echo "scale=2;${pourcentage:-100}/100" | bc))"

		old_pourcentage=${pourcentage}

		# Mini sleep
		sleep 0.1

	elif [[ ${ligne} =~ Error ]]
	then
		# Debug et info
		echo "SET@_progressbar1.set_text(' $(eval_gettext $'Error: see the debug.') ')"
		echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'An error occurred during the encapsulation.')\\n<blue>${ligne}</blue>\\n"
		echo 'SET@_progressbar1.set_fraction(1)'
		return
	fi
done < <(eval ${mkvmerge} 2>&1)

# Récupération de l'heure en seconde pour calculer le temps écoulé.
temps_b=$(date +%s)

calcul_temps temps_a temps_b

# Debug et info
echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>---------------------------------------</red>\\n$(eval_gettext $'Tracks encapsulation completed in:') <blue>${temps}</blue>.\\n"
echo "SET@_progressbar1.set_text(' $(eval_gettext $'Tracks encapsulation completed in:') ${temps} ')"
echo 'SET@_progressbar1.set_fraction(1)'
}


###################
##### Boutons #####
###################
function _bouton_quit
{
if [[ ${1} == clic_droit ]]
then
	reload=yes

	# Appuie graphiquement sur le bouton
	echo 'SET@_bouton_quit.activate()'

else
	# Sauvegarde des préférences
	echo 'CONFIG@@SAVE'

	# Fenetre cachée
	echo 'SET@_window1.hide()'; sleep 0.1

	# Modification de la variable de l'adresse du fichier mkv dans le fichier de config
	sed -i "/^_fichier_mkv/ s@= \(.*\)/.*@= \1@" "${config}"

	# Arret de mplayer
	echo "PLUGIN@@CMD@@MyPlayer@@cmd.quit(0)"

	# Suppression du dossier temporaire s'il existe... Necessaire en cas de reboot
	[[ -d "${tmp}" ]] && rm -r "${tmp}" &

	# Kill de mplayer si pas encore arreter
	[[ $(ps h -p ${mplayerPID} 2>/dev/null) ]] && kill -9 ${mplayerPID}

	# Arret des actions en cours
	_bouton_stop

	# Arret ou reboot du logiciel
	[[ ${reload} == yes ]] && echo 'EXIT@@SAVE' || echo 'EXIT@@'
fi
}

function _mkvinfo { mkvinfo -g "${G2S_fichier_mkv}" & }

function _bouton_stop
{
# Si aucune action en cours, on arrete là
[[ $(< "${tmp}/action_en_cours") != True ]] && return

echo "False" > "${tmp}/action_en_cours"

# Récuération des sous pid
[[ ${pid_actions} ]] && { sous_pid_actions=$(ps --ppid ${pid_actions} -o pid=); sous_sous_pid_actions=$(ps --ppid ${sous_pid_actions} -o pid=); }

# Suppression des fichiers si actions est toujours lancé
[[ $(ps h -p ${pid_actions} 2>/dev/null) ]] && rm "${fichiers[@]}"

# Kill des pids
for pid in ${sous_sous_pid_actions} ${sous_pid_actions} ${pid_actions} ${pid_verifier_mkv} ${pid_reparer_mkv}
do
	[[ $(ps h -p ${pid} 2>/dev/null) ]] && kill ${pid}
done

# Si c'est le bouton quit qui à appeller la fonction, on arrete la
[[ ${FUNCNAME[1]} == _bouton_quit ]] && return

echo 'SET@_progressbar1.set_fraction(0)'
echo "SET@_progressbar1.set_text(' $(eval_gettext $'Canceling and deleting files completed.') ')"
echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>---------------------------------------</red>\\n<red>$(eval_gettext $'Cancellation of running processes and delete files completed.')</red>\\n<red>---------------------------------------</red>\\n"

# Remis en place des coches en relancant la fonction treeview
echo "TREE@@HIZO@@treeview1"

# Pour laisser le temps de lire le texte ci-dessus
sleep 1

# Affichage de l'onglet des pistes
echo 'SET@_notebook2.set_current_page(1)'
}


############################################
##### Visualisation des pièces jointes #####
############################################
function _info_media
{
if [[ ${etat_infos} == True ]]
then
	etat_infos=False

	# Modifications graphiques
	echo 'SET@_frame_info.hide()'
	echo 'SET@_frame_attache.show()'
	echo 'SET@_info_media.set_label("gtk-info")'

else
	etat_infos=True

	# Affichage de la duree pour les audio/videos et une seule fois
	if [[ ${format_length} && ${time_info} != True && ${type} =~ video|audio|media ]]
	then
		echo "TEXT@@ENDTAG@@_text_info@@\\n\\n$(eval_gettext $'Duration:') <blue>${format_length%.*}</blue>"
		time_info=True
	fi

	# Modifications graphiques
	echo 'SET@_frame_attache.hide()'
	echo 'SET@_frame_info.show()'
	echo 'SET@_info_media.set_label("gtk-go-back")'
fi
}


function _open_media
{
# Affichage de l'image avec le logiciel par defaut
case ${type} in
	web|media|image|audio|video|text) xdg-open "${tmp}/attachments_${ID}" & ;;
	chapters|tags) xdg-open "${tmp}/${type}" & ;;
esac
}


# Fonction gerant l'avancement de la barre de chargement de la video
function ProgressPlayerCb
{
# Si la variable est à True, on arrete là
[[ ${flag_scale} == True ]] && return

# Récupération des variables
retours=${@} retours=${retours#*@}
eval ${retours//@@/ }

# Envoie du pourcentage
echo "SET@_barre_video.set_value(${percent})"
}


# Avancement de la video lors du deplacement de la barre
function _barre_video
{
# Récupération des variables
arg=${@} pref=${arg%%@*} arg=${arg#*@}

case ${pref} in
	press_event )
		flag_scale=True ;;

	release_event )
		flag_scale=False
		echo "PLUGIN@@CMD@@MyPlayer@@cmd.seek('${scale} 1')" ;;

	[0-9]* )
		scale=${arg} ;;
esac
}


function MyPlayer
{
# Si pas d'argument, on quitte la fonction
[[ -z ${@} ]] && return

# Récuperation des infos
( arg=${@} pref=${arg%%@*} arg=${arg#*@} arg=${arg//</←} arg=${arg//>/→}
eval ${arg//@@/ }

# Si ce ne sont pas des infos sur les pistes, on arrete là
[[ ${pref} != mediainfo ]] && return

# Envoie des infos
case ${type} in
	video)
		echo "TEXT@@ENDTAG@@_text_info@@<red>=====~ $(eval_gettext $'AUDIO') -~=====</red>\\n$(eval_gettext $'Decoder:') <blue>${audio_decoder}</blue>\\n$(eval_gettext $'Output folder:') <blue>${audio_output}</blue>\\n$(eval_gettext $'Informations:') <blue>${audio_info}</blue>\\n$(eval_gettext $'Codec:') <blue>${audio_codec}</blue>\\n\\n<red>=====~- $(eval_gettext $'VIDEO')-~=====</red>\\n$(eval_gettext $'Decoder:') <blue>${video_decoder}</blue>\\n$(eval_gettext $'Informations:') <blue>${video_info}</blue>\\n$(eval_gettext $'Codec:') <blue>${video_codec}</blue>"

		# Modifications graphiques
		sleep 0.5 ; echo 'SET@_taf.hide()'
		echo 'MULTI@@SET@@show()@@_video_box,_mediaview' ;;

	audio)
		echo "TEXT@@ENDTAG@@_text_info@@$(eval_gettext $'Decoder:') <blue>${audio_decoder}</blue>\\n$(eval_gettext $'Output folder:') <blue>${audio_output}</blue>\\n$(eval_gettext $'Informations:') <blue>${audio_info}</blue>\\n$(eval_gettext $'Codec:') <blue>${audio_codec}</blue>"

		# Modifications graphiques
		echo "IMG@@_visualisation_img@@/usr/share/icons/hicolor/256x256/apps/mkv-extractor-gui.png@@${_visualisation_img_scale% *}@@${_visualisation_img_scale#* }"
		sleep 0.5 ; echo 'SET@_taf.hide()'
		echo 'MULTI@@SET@@show()@@_video_box,_hbox_img' ;;

	media) # Pour les ogg dont on ignore si audio ou video
		if [[ ${video_codec:-None} != None ]]
		then
			echo "TEXT@@ENDTAG@@_text_info@@<red>=====~ $(eval_gettext $'AUDIO') -~=====</red>\\n$(eval_gettext $'Decoder:') <blue>${audio_decoder}</blue>\\n$(eval_gettext $'Output folder:') <blue>${audio_output}</blue>\\n$(eval_gettext $'Informations:') <blue>${audio_info}</blue>\\n$(eval_gettext $'Codec:') <blue>${audio_codec}</blue>\\n\\n<red>=====~- $(eval_gettext $'VIDEO')-~=====</red>\\n$(eval_gettext $'Decoder:') <blue>${video_decoder}</blue>\\n$(eval_gettext $'Informations:') <blue>${video_info}</blue>\\n$(eval_gettext $'Codec:') <blue>${video_codec}</blue>"

			# Modifications graphiques
			sleep 0.5 ; echo 'SET@_taf.hide()'
			echo 'MULTI@@SET@@show()@@_video_box,_mediaview'
		else
			echo "TEXT@@ENDTAG@@_text_info@@$(eval_gettext $'Decoder:') <blue>${audio_decoder}</blue>\\n$(eval_gettext $'Output folder:') <blue>${audio_output}</blue>\\n$(eval_gettext $'Informations:') <blue>${audio_info}</blue>\\n$(eval_gettext $'Codec:') <blue>${audio_codec}</blue>"

			# Modifications graphiques
			echo "IMG@@_visualisation_img@@/usr/share/icons/hicolor/256x256/apps/mkv-extractor-gui.png@@${_visualisation_img_scale% *}@@${_visualisation_img_scale#* }"
			sleep 0.5 ; echo 'SET@_taf.hide()'
			echo 'MULTI@@SET@@show()@@_video_box,_hbox_img'
		fi ;;
esac )

# Modifications graphiques avec sleep pour être sur que les variables sont présentes
( sleep 0.5; echo 'MULTI@@SET@@set_sensitive(True)@@_info_media,_open_media'; ) &
}


function tree_pistes()
{
# Si pas d'argument, on quitte la fonction
[[ -z ${@} ]] && return

# Modifications graphiques
echo 'MULTI@@SET@@hide()@@_scrolle_txt,_hbox_img,_video_box,_mediaview,_webbox'
echo 'MULTI@@SET@@set_sensitive(False)@@_info_media,_open_media'
echo 'TEXT@@CLEAR@@_text_info'
sleep 0.05
echo 'SET@_taf.show()'

# Variable pour l'affichage du temps de la video ou de l'audio
time_info=False

# Arrete la lecture si besoin
action_video stop

# Récupération des infos dans leurs variables
piste=${@#*@} ID=${piste%%|*} type=${piste#*|} type=${type%%|*} nom=${piste#*|*|} nom=${nom%%|*}

# Info pour le debug profond
[[ ${G2S_debug} == True ]] && echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>------</red>$(eval_gettext $'Attachment')<red>------</red>\\npiste : <blue>${piste}</blue>\\nID : <blue>${ID}</blue>\\ntype : <blue>${type}</blue>\\nnom : <blue>${nom}</blue>\\n<red>------</red>$(eval_gettext $'Attachment')<red>------</red>\\n"

case ${type} in
	image)
		# Extraction du fichier joint s'il n'existe pas
		if [[ ! -e "${tmp}/attachments_${ID}" ]]
		then
			mkvextract attachments "${G2S_fichier_mkv}" ${ID}:"${tmp}/attachments_${ID}"

			if [[ ${identify} == True ]]
			then
				echo "$(identify -format "$(eval_gettext $'Format:') <blue>%m</blue>\\\n$(eval_gettext $'Resolution:') <blue>%G px</blue>\\\n$(eval_gettext $'Quality:') <blue>%Q</blue>\\\n$(eval_gettext $'Depth:') <blue>%z bits</blue>\\\n$(eval_gettext $'Weight:') <blue>%b bytes</blue>" "${tmp}/attachments_${ID}")" > "${tmp}/attachments_${ID}_info"
			fi
		fi

		if [[ ${identify} == True ]]
		then
			# Envoie des infos sur l'image
			var=$(< ${tmp}/attachments_${ID}_info)
			echo "TEXT@@ENDTAG@@_text_info@@${var}"

		else
			# Message indiquant qu'il manque imagemagick
			echo "TEXT@@ENDTAG@@_text_info@@$(eval_gettext $'The imagemagick package is not installed')"
		fi

		# Modifications graphiques
		echo "IMG@@_visualisation_img@@${tmp}/attachments_${ID}@@${_visualisation_img_scale% *}@@${_visualisation_img_scale#* }"
		sleep 0.1 ; echo 'SET@_taf.hide()'
		echo 'SET@_hbox_img.show()'
		echo 'MULTI@@SET@@set_sensitive(True)@@_info_media,_open_media' ;;

	chapters|tags)
		# Extraction du fichier s'il n'existe pas
		if [[ ! -e "${tmp}/${type}" ]]
		then
			[[ ${type} == chapters ]] && mkvextract ${type} "${G2S_fichier_mkv}" -s > "${tmp}/${type}" || mkvextract ${type} "${G2S_fichier_mkv}" > "${tmp}/${type}"
		fi

		# Chargement du fichier
		echo "TEXT@@LOAD@@_visualisation_txt@@${tmp}/${type}"

		# Envoie des infos sur le texte
		echo "TEXT@@ENDTAG@@_text_info@@$(file -b "${tmp}/${type}")"

		# Modifications graphiques
		sleep 0.1 ; echo 'SET@_taf.hide()'
		echo 'SET@_scrolle_txt.show()'
		echo 'MULTI@@SET@@set_sensitive(True)@@_info_media,_open_media' ;;

	text)
		[[ ! -e "${tmp}/attachments_${ID}" ]] && mkvextract attachments "${G2S_fichier_mkv}" ${ID}:"${tmp}/attachments_${ID}" && iconv -f ISO-8859-1 -t UTF8 "${tmp}/attachments_${ID}" -o "${tmp}/attachments_${ID}"

		# Chargement du fichier
		echo "TEXT@@LOAD@@_visualisation_txt@@${tmp}/attachments_${ID}"

		# Envoie des infos sur le texte
		echo "TEXT@@ENDTAG@@_text_info@@$(file -b "${tmp}/attachments_${ID}")"

		# Modifications graphiques
		sleep 0.1 ; echo 'SET@_taf.hide()'
		echo 'SET@_scrolle_txt.show()'
		echo 'MULTI@@SET@@set_sensitive(True)@@_info_media,_open_media' ;;

	web)
		[[ ! -e "${tmp}/attachments_${ID}" ]] && mkvextract attachments "${G2S_fichier_mkv}" ${ID}:"${tmp}/attachments_${ID}"

		if [[ ${webkit} == True ]]
		then
			echo "WEBKIT@@LOAD@@test@@${tmp}/attachments_${ID}"

			# Modifications graphiques
			sleep 0.1 ; echo 'SET@_taf.hide()'
			echo 'SET@_webbox.show()'
			echo 'MULTI@@SET@@set_sensitive(True)@@_info_media,_open_media'

		else
			# Message indiquant qu'il manque python-webkit
			echo "TEXT@@END@@_text_info@@$(eval_gettext $'The python-webkit package is not installed')"

			# Modifications graphiques
			sleep 0.1 ; echo 'SET@_taf.hide()'
			echo 'SET@_scrolle_txt.show()'
			echo 'MULTI@@SET@@set_sensitive(True)@@_info_media,_open_media'
		fi ;;

	audio)
		# Extraction du fichier joint
		[[ ! -e "${tmp}/attachments_${ID}" ]] && mkvextract attachments "${G2S_fichier_mkv}" ${ID}:"${tmp}/attachments_${ID}"

		if [[ ${mplayer} == True ]]
		then
			# Lancement de la video
			echo "PLUGIN@@CMD@@MyPlayer@@loadfile('${tmp}/attachments_${ID}')"
			action_video play

		else
			# Message indiquant qu'il manque python-webkit
			echo "TEXT@@END@@_text_info@@$(eval_gettext $'The mplayer package is not installed')"

			# Modifications graphiques
			sleep 0.1 ; echo 'SET@_taf.hide()'
			echo 'SET@_scrolle_txt.show()'
			echo 'MULTI@@SET@@set_sensitive(True)@@_info_media,_open_media'
		fi ;;

	video)
		# Extraction du fichier joint
		[[ ! -e "${tmp}/attachments_${ID}" ]] && mkvextract attachments "${G2S_fichier_mkv}" ${ID}:"${tmp}/attachments_${ID}"

		if [[ ${mplayer} == True ]]
		then
			# Lancement de la video
			echo "PLUGIN@@CMD@@MyPlayer@@loadfile('${tmp}/attachments_${ID}')"
			action_video play

		else
			# Message indiquant qu'il manque python-webkit
			echo "TEXT@@END@@_text_info@@$(eval_gettext $'The mplayer package is not installed')"

			# Modifications graphiques
			sleep 0.1 ; echo 'SET@_taf.hide()'
			echo 'SET@_scrolle_txt.show()'
			echo 'MULTI@@SET@@set_sensitive(True)@@_info_media,_open_media'
		fi ;;

	media) # Dans le cas des ogg qui peuvent être video ou audio
		# Extraction du fichier joint
		[[ ! -e "${tmp}/attachments_${ID}" ]] && mkvextract attachments "${G2S_fichier_mkv}" ${ID}:"${tmp}/attachments_${ID}"

		if [[ ${mplayer} == True ]]
		then
			# Lancement du fichier
			echo "PLUGIN@@CMD@@MyPlayer@@loadfile('${tmp}/attachments_${ID}')"
			action_video play

		else
			# Message indiquant qu'il manque python-webkit
			echo "TEXT@@END@@_text_info@@$(eval_gettext $'The mplayer package is not installed')"

			# Modifications graphiques
			sleep 0.1 ; echo 'SET@_taf.hide()'
			echo 'SET@_scrolle_txt.show()'
			echo 'MULTI@@SET@@set_sensitive(True)@@_info_media,_open_media'
		fi ;;
esac
}


function etat_video
{
if [[ ${etat} == play ]]
then
	# Si le fichier est en lecture, on le met en pause
	action_video pause

elif [[ ${etat} == pause ]]
then
	# Si le fichier est en pause, on le met en lecture
	action_video play
fi
}


function action_video
{
# Si pas d'argument, on quitte la fonction
[[ -z ${1} ]] && return

if [[ ${1} == play ]]
then
	# Modification du bouton en pause
	echo 'SET@_img_video.set_from_stock("gtk-media-pause", gtk.ICON_SIZE_BUTTON)'

	# Si le multimedia était en pause, retour en lecture
	[[ ${etat} == pause ]] && echo 'PLUGIN@@CMD@@MyPlayer@@pause()'

elif [[ ${1} == pause ]]
then
	# Modification du bouton en play
	echo 'SET@_img_video.set_from_stock("gtk-media-play", gtk.ICON_SIZE_BUTTON)'

	# Si le multimedia était en play, mise en pause
	[[ ${etat} == play ]] && echo 'PLUGIN@@CMD@@MyPlayer@@pause()'

elif [[ ${1} == stop ]]
then
	# Modification du bouton en pause car le prochain fichier se lancera automatiquement
	echo 'SET@_img_video.set_from_stock("gtk-media-pause", gtk.ICON_SIZE_BUTTON)'

	# Si le media est en pause, il faut le remettre en play avant son arret
	[[ ${etat} == pause ]] && echo 'PLUGIN@@CMD@@MyPlayer@@pause()'

	# Arret du multimedia s'il n'était pas deja arrete
	[[ ${etat:-stop} != stop ]] && echo 'PLUGIN@@CMD@@MyPlayer@@cmd.stop()'
fi

# Récuperation du nouvel etat
etat=${1}
}


##############################
##### Test et réparation #####
##############################
function _verifier_mkv
{
if [[ ${1} == clicked ]]
then
	_verifier_mkv &
	pid_verifier_mkv=${!}
	echo "True" > "${tmp}/action_en_cours"
else
	# Récupération de l'heure en seconde pour calculer le temps écoulé.
	temps_a=$(date +%s)

	echo 'TOGGLE@@VISIBLE@@_bouton_stop,_bouton_extract'
	echo 'SET@_progressbar1.set_fraction(0)'

	#* Lancement de la commande
	echo "TERM@@SEND@@mkvalidator --no-warn \"${G2S_fichier_mkv}\"\n"

	# Debug et info
	echo "SET@_progressbar1.set_text(' $(eval_gettext $'MKV checking in progress...') ')"
	echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'mkvalidator command:')\\n<blue>mkvalidator --no-warn '${G2S_fichier_mkv}'</blue>\\n"

	#* Mise en attente du script et pulsation de la barre de chargement
	sleep 0.5; while [[ $(ps --ppid ${G2S_TERMINAL_PID} -o pid= 2>/dev/null) ]]; do echo 'SET@_progressbar1.pulse()'; sleep 0.2; done

	# Récupération de l'heure en seconde pour calculer le temps écoulé.
	temps_b=$(date +%s)

	calcul_temps temps_a temps_b

	# Debug et info
	echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>---------------------------------------</red>\\n$(eval_gettext $'MKV checking completed in:') <blue>${temps}</blue>.\\n"
	echo "SET@_progressbar1.set_text(' $(eval_gettext $'MKV checking completed in:') ${temps} ')"
	echo 'SET@_progressbar1.set_fraction(1)'

	echo "MULTI@@SET@@set_sensitive(True)@@_table1,_vbox4,_hbox4,_vbox5"
	echo 'TOGGLE@@VISIBLE@@_bouton_stop,_bouton_extract'

	echo "False" > "${tmp}/action_en_cours"
fi
}


function _reparer_mkv
{
if [[ ${1} == clicked ]]
then
	_reparer_mkv &
	pid_reparer_mkv=${!}
	echo "True" > "${tmp}/action_en_cours"

else
	# Récupération de l'heure en seconde pour calculer le temps écoulé.
	temps_a=$(date +%s)

	echo 'TOGGLE@@VISIBLE@@_bouton_stop,_bouton_extract'
	echo 'SET@_progressbar1.set_fraction(0)'

	# Lancement de la commande
	echo "TERM@@SEND@@mkclean --optimize \"${G2S_fichier_mkv}\" \"${G2S_dossier_save}/mkclean-${fichier_mkv##*/}\"\n"

	# Debug et info
	echo "SET@_progressbar1.set_text(' $(eval_gettext $'MKV repairing in progress...') ')"
	echo "TEXT@@ENDTAG@@_textedebug@@\\n$(eval_gettext $'mkclean command:')\\n<blue>mkclean --optimize '${G2S_fichier_mkv}'</blue>\\n"

	#* Mise en attente du script et pulsation de la barre de chargement
	sleep 0.5; while [[ $(ps --ppid ${G2S_TERMINAL_PID} -o pid= 2>/dev/null) ]]; do echo 'SET@_progressbar1.pulse()'; sleep 0.2; done

	[[ ${G2S_remplacer} == True ]] && echo "TERM@@SEND@@mv -f \"${G2S_dossier_save}/mkclean-${fichier_mkv##*/}\" \"${G2S_fichier_mkv}\"\n"

	# Récupération de l'heure en seconde pour calculer le temps écoulé.
	temps_b=$(date +%s)

	calcul_temps temps_a temps_b

	# Debug et info
	echo "TEXT@@ENDTAG@@_textedebug@@\\n<red>---------------------------------------</red>\\n\\n$(eval_gettext $'MKV repairing completed in:') <blue>${temps}</blue>.\\n"
	echo "SET@_progressbar1.set_text(' $(eval_gettext $'MKV repairing completed in:') ${temps} ')"
	echo 'SET@_progressbar1.set_fraction(1)'

	echo "MULTI@@SET@@set_sensitive(True)@@_table1,_vbox4,_hbox4,_vbox5"
	echo 'TOGGLE@@VISIBLE@@_bouton_stop,_bouton_extract'

	echo "False" > "${tmp}/action_en_cours"
fi
}


#######################
##### Préférences #####
#######################
function open_pref { xdg-open "${config}"; }

function del_pref
{
# Création d'un nouveau fichier de config
echo "[TOGGLE]
_canaux = False
_fichier_tmp = True
_debug = False
_auto_save = False
_remplacer = False
_nautilus = $( [[ -f "${HOME}/.gnome2/nautilus-scripts/mkv-extractor-gui.sh" || -f "${HOME}/.kde/share/kde4/services/mkv-extractor-gui.desktop" ]] && echo "True" || echo "False" )

[COMBO]
_bitrate = 0
_langue = 1
_boost = 0

[FILECHOOSER]
_fichier_mkv =
_dossier_save =" > "${config}"

# Récupération des variables
echo "CONFIG@@GET@@@@@@${config}"; sleep 0.1

# Chargement graphique de ce nouveau fichier
echo "CONFIG@@LOAD@@@@@@${config}"
}


########################
##### Introduction #####
########################
### Variables
mkv_extractor_gui="${HOME}/.config/mkv-extractor-gui"
config="${mkv_extractor_gui}/config.cfg"
log="${mkv_extractor_gui}/mkv-extractor-gui.log"
tmp=$(mktemp -d /tmp/mkv-extractor-gui.XXX)
version='4.8.1'
flag_scale=False

# Variables en fonction de la langue
tags="$(eval_gettext $'Tags')"
chapters="$(eval_gettext $'Chapters')"

# Gestion du fichier log enregistrant tout probleme
[[ -e "${log}" ]] && rm "${log}"
exec 2>> "${log}"

# Affichage de la fenetre
echo 'SET@_window1.show()'

# Modification graphique
echo 'MULTI@@SET@@hide()@@_scrolle_txt,_video_box,_mediaview,_webbox'
echo 'SET@_hbox_img.show()'
echo 'FILE@@SETFILTER@@_fichier_mkv@@add_mime_type@@video/x-matroska'
echo 'TEXT@@CREATETAG@@_textedebug,_text_info@@blue@@foreground=blue,style=pango.STYLE_ITALIC'
echo 'TEXT@@CREATETAG@@_textedebug,_text_info@@red@@foreground=red,style=pango.STYLE_ITALIC'
echo 'SET@_textedebug.set_wrap_mode(gtk.WRAP_WORD)'
echo 'SET@terminal.set_font( pango.FontDescription("monospace 8") )'
echo 'SET@terminal.set_scrollback_lines(-1)'
echo "SET@_window1.set_title('MKV Extractor Gui v${version} - by Hizoka')"
echo "SET@MKV_Extractor_Gui.set_version('v${version}')"

# Commandes pour mplayer
echo 'PLUGIN@@INIT@@g2sPluginMplayer@@MyPlayer@@_mediaview@@None@@ProgressPlayerCb@@None'
echo "EXEC@@self.MyPlayer.player.isVideo = True"

# Le changement de page doit se faire apres l'affichage du logiciel sinon mplayer ne fonctionne pas
[[ ! -f "${G2S_fichier_mkv}" ]] && echo 'SET@_notebook2.set_current_page(1)'

#######################################
##### Chargement  des préférences #####
#######################################
# Chargement des valeurs des combobox
case ${G2S_bitrate} in
	0) G2S_bitrate=128 ;;
	1) G2S_bitrate=192 ;;
	2) G2S_bitrate=224 ;;
	3) G2S_bitrate=256 ;;
	4) G2S_bitrate=320 ;;
	5) G2S_bitrate=384 ;;
	6) G2S_bitrate=448 ;;
	7) G2S_bitrate=512 ;;
	8) G2S_bitrate=576 ;;
	9) G2S_bitrate=640 ;;
esac

case ${G2S_boost} in
	0) G2S_boost=0 ;;
	1) G2S_boost=2 ;;
	2) G2S_boost=3 ;;
	3) G2S_boost=4 ;;
	4) G2S_boost=5 ;;
esac

# Variables pour savoir si les logiciels sont installés
[[ $(type -p identify) ]] && identify=True || identify=False
[[ $(type -p mplayer) ]] && mplayer=True || mplayer=False
python -c 'import webkit' 2>/dev/null && webkit=True || webkit=False

if [[ -z $(type -p mkclean) ]]
then
	echo 'SET@_reparer_mkv.set_sensitive(False)'
	echo 'SET@_remplacer.set_sensitive(False)'
	echo "TERM@@WRITE@@$(eval_gettext $'The mkclean package is not installed')\\n"
fi

if [[ -z $(type -p mkvalidator) ]]
then
	echo 'SET@_verifier_mkv.set_sensitive(False)'
	echo "TERM@@WRITE@@$(eval_gettext $'The mkvalidator package is not installed')\\n"
fi

# Charge la video si elle existe
[[ -f "${G2S_fichier_mkv}" ]] && _fichier_mkv "${G2S_fichier_mkv}"


######################################################################################################

while read ligne
do
	if [[ ${ligne} =~ GET@ ]]
	then
		eval ${ligne#*@}
		echo "DEBUG => in boucle bash :" ${ligne#*@}
	else
		echo "DEBUG=> in bash NOT GET" ${ligne}
		${ligne}
	fi
done < <(while true
do
	read entree < ${FIFO}
	[[ ${entree}  == QuitNow ]] && break
	echo ${entree}
done)

[[ -e /tmp/FIFO${PID} ]] && rm /tmp/FIFO${PID}

exit
